/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CloneTarget type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CloneTarget{}

// CloneTarget struct for CloneTarget
type CloneTarget struct {
	// Organization where interaction will be cloned
	OrganizationId string `json:"organization_id"`
	// Channel where interaction will be cloned
	ChannelId string `json:"channel_id"`
}

// NewCloneTarget instantiates a new CloneTarget object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCloneTarget(organizationId string, channelId string) *CloneTarget {
	this := CloneTarget{}
	this.OrganizationId = organizationId
	this.ChannelId = channelId
	return &this
}

// NewCloneTargetWithDefaults instantiates a new CloneTarget object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCloneTargetWithDefaults() *CloneTarget {
	this := CloneTarget{}
	return &this
}

// GetOrganizationId returns the OrganizationId field value
func (o *CloneTarget) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *CloneTarget) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *CloneTarget) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetChannelId returns the ChannelId field value
func (o *CloneTarget) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *CloneTarget) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *CloneTarget) SetChannelId(v string) {
	o.ChannelId = v
}

func (o CloneTarget) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CloneTarget) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["channel_id"] = o.ChannelId
	return toSerialize, nil
}

type NullableCloneTarget struct {
	value *CloneTarget
	isSet bool
}

func (v NullableCloneTarget) Get() *CloneTarget {
	return v.value
}

func (v *NullableCloneTarget) Set(val *CloneTarget) {
	v.value = val
	v.isSet = true
}

func (v NullableCloneTarget) IsSet() bool {
	return v.isSet
}

func (v *NullableCloneTarget) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCloneTarget(val *CloneTarget) *NullableCloneTarget {
	return &NullableCloneTarget{value: val, isSet: true}
}

func (v NullableCloneTarget) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCloneTarget) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


